var selectedRow = null;

function SelectRow(thisRow)
{
	if(selectedRow != null) {
		UnHighlightRow(selectedRow);
		selectedRow = null;
	}

	HighlightRow(thisRow);
    thisRow.focus();
	selectedRow = thisRow;
    var nRow = getDigits(thisRow.id);
	var oRule = oRules(nRow);
	ShowDetails(oRule);
    window.external.lastRowSel(nRow);
}

function HighlightRow(targetRow)
{
	// "e" corresponds to enabled rows
	// "d" corresponds to disabled rows
	if (targetRow.className.charAt(0) == "e")
		document.getElementById(targetRow.id).className = "enabledRowSelected";
	else
		document.getElementById(targetRow.id).className = "disabledRowSelected";

	eval("document.all('" + targetRow.id + "col3').className = \"enabledColumnSelected\"");
}

function UnHighlightRow(targetRow)
{
	if (targetRow.className.charAt(0) == "e")
		document.getElementById(targetRow.id).className = "enabledRow";
	else
		document.getElementById(targetRow.id).className = "disabledRow";

	eval("document.all('" + targetRow.id + "col3').className = \"enabledColumn\"");
}

function HoverRow(targetRow)
{
	if (targetRow.className.charAt(0) == "e") {
		if (targetRow != selectedRow)
			document.getElementById(targetRow.id).className = "enabledRowHover";
		else
			document.getElementById(targetRow.id).className = "enabledRowSelectedHover";
	}
	else {
		if (targetRow != selectedRow)
			document.getElementById(targetRow.id).className = "disabledRowHover";
		else
			document.getElementById(targetRow.id).className = "disabledRowSelectedHover";
	}
}

function UnHoverRow(targetRow)
{
	if (targetRow != selectedRow)
		UnHighlightRow(targetRow);
	else
		HighlightRow(targetRow);
}

function SwitchRows(firstRowNumber, secondRowNumber)
{
	var firstRow = eval("document.all.row" + firstRowNumber);
	var secondRow = eval("document.all.row" + secondRowNumber);

	var firstRowCol1 = eval("document.all.row" + firstRowNumber + "col1");
	var firstRowCol3 = eval("document.all.row" + firstRowNumber + "col3");
	var secondRowCol1 = eval("document.all.row" + secondRowNumber + "col1");
	var secondRowCol3 = eval("document.all.row" + secondRowNumber + "col3");

	var firstRowEnabled = eval("document.all.cb" + firstRowNumber);
	var secondRowEnabled = eval("document.all.cb" + secondRowNumber);

	tempEnabledChecked = firstRowEnabled.checked;

	var tempclassName = firstRow.className;

	firstRow.className = secondRow.className;
	firstRowEnabled.checked = secondRowEnabled.checked;

	secondRow.className = tempclassName;
	secondRowEnabled.checked = tempEnabledChecked;

	var tempCol1InnerHTML = firstRowCol1.innerHTML;
	var tempCol3InnerHTML = firstRowCol3.innerHTML;
	var tempCol1className = firstRowCol1.className;
	
	firstRowCol1.innerHTML = secondRowCol1.innerHTML;
	firstRowCol1.className = secondRowCol1.className;
	firstRowCol3.innerHTML = secondRowCol3.innerHTML;
	firstRowCol3.className = "enabledColumn";

	secondRowCol1.innerHTML = tempCol1InnerHTML;
	secondRowCol1.className = tempCol1className;
	secondRowCol3.innerHTML = tempCol3InnerHTML;
	secondRowCol3.className = "enabledColumn";


	secondRow.scrollIntoView();
	selectedRow = firstRow;

	SelectRow(secondRow);
}

function MoveUp()
{
	if(selectedRow != null) {
		var currentRowNumber = getDigits(selectedRow.id);
		var previousRowNumber = parseInt(currentRowNumber) - 1;

		if (typeof eval("document.all.row" + previousRowNumber) != "undefined") {
			var orules = window.external.getRules();
			if (orules.moveUp(currentRowNumber)) 
                SwitchRows(currentRowNumber, previousRowNumber);
		}
	}
	else {
		alert(window.external.getResourceString(IDS_JS_E_OK_SELECTROWMOVEUP));
	}
}

function MoveDown()
{
	if(selectedRow != null) {

		var currentRowNumber = getDigits(selectedRow.id);
		var nextRowNumber = parseInt(currentRowNumber) + 1;

		if (typeof eval("document.all.row" + nextRowNumber) != "undefined") {
			var orules = window.external.getRules();
			if (orules.moveDown(currentRowNumber)) 
                SwitchRows(currentRowNumber, nextRowNumber);
		}
	}
	else {
		alert(window.external.getResourceString(IDS_JS_E_OK_SELECTROWMOVEDOWN));
	}
}